package ihm;

import java.util.Vector;
import javax.swing.JComponent;

class AlertThread extends Thread {
   private Vector alertStack;
   private Vector symbList;
   private JComponent dc;
   private boolean running = true;

   AlertThread(Vector alerts, Vector symboles, JComponent drawingComponent) {
      super ("Thread d'alertes");
      alertStack = alerts;
      symbList = symboles;
      dc = drawingComponent;
   }

   public void run() {
      Vector alerts = new Vector();
      boolean thereAreAlerts = false;

      while (running) {
         synchronized (alertStack) {
            // Processus peu couteux en temps:(donc synchronis avec la pile d'alertes,
            // qui doit rester hautement disponible, notamment parceque d'autre threads
            // doivent pouvoir y accder sans tre bloqus:
            // recopie dans un tableau des alertes en attente, et
            // vidage de la pile d'alertes.
            if ((thereAreAlerts = (alertStack.size() > 0))) {
               alerts.addAll (alertStack);
               alertStack.removeAllElements();
            }
         }
         
         if (thereAreAlerts) {
            // La synchronisation (couteuse en temps) ne se fait que si c'est ncessaire,
            // c'est  dire si des alertes sont en attente d'tre distribues.
            synchronized (symbList) {
               for (int ai = 0; ai < alerts.size(); ai++) {
                  Symbole s = null;
                  for (int si = 0; (s == null) && (si < symbList.size()); si++) {
                     if (((Symbole)symbList.elementAt(si)).getID() == ((Alert)alerts.elementAt(ai)).getID()) {
                        s = (Symbole)symbList.elementAt(si);                       
                     }
                  }
                  if (s != null) {
                     synchronized (s) {
                        s.addAlert (((Alert)alerts.elementAt(ai)).toString());
                     }
                  }
               }
            }
            alerts.removeAllElements();
            synchronized (dc) {
               dc.repaint();
            }
         }
         // Une petite pause pour pas trop faire le gourmand...
         try {
            sleep (250);
         } catch (InterruptedException ie) {
         }
      }
   }

   public void finish () {
      running = false;
   }
}
