package ihm;

import ihm.IHM;

/**
 * L'interface IHM - Moteur, seule du package <code>ihm</code> visible
 * par le Moteur.
 * <p>
 * Cette inerface prsente les quelques mthodes que doit
 * implmenter la classe de l'IHM qui sera visible du moteur.
 * </p>
 * @author      M2SSI SNMP
 * @version     %I%, %G%
 * @since       1.0
 */
public interface IHMMoteur {
/**
 * Notifie l'IHM qu'une alerte est arrive.
 * <p>
 * L'appel  cette fonction est non bloquant, et thread-safe.
 * De plus il peut tre fait indpendamment du traitement des alertes par l'IHM.
 * </p>
 *
 * @param origID l'metteur de l'alerte, dsign par son ID
 * @param msg le message de l'alerte
 * @param date la date de l'alerte
 * @since 1.0
 */
   public void notifyAlert (int origID, String msg, java.util.Date date);
   
 /**
 * Initialisation de l'IHM.
 * <p>
 * L'initialisation doit tre faite par le moteur, une fois celui-ci prt
 *  fonctionner.
 * </p>
 * 
 * @param mi l'interface <code>MoteurIHM</code> du moteur qui initialise.
 * @return true si l'initialisation s'est bien pass, false sinon.
 * @since 1.0
 */
   public boolean init(moteur.MoteurIHM mi);
   
 /**
  * Finalise l'IHM pour la prparer  se fermer.
  * <p>
  * Avant de fermer l'application, le moteur demande  l'interface
  * de se prparer  se fermer.
  * Cette mthode ne doit pas retourner avant que l'interface soit
  * effectivement prte.
  * </p>
  *
  * @since 1.0
  */
    public void finalize();
}