package ihm;

import java.awt.*;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseMotionListener;
import java.util.*;
import java.util.Vector;
import javax.swing.*;

/**
 * C'est la classe qui dfinit la zone centrale de dessin de l'application.
 * Il faut l'instancier et l'ajouter dans le conteneur principal de
 * l'application, l'interface.
 */
public class PanelDraw extends JPanel {

/**
 * 
 */
    private int mouseLastX;
/**
 * 
 */
    private int mouseLastY;

/**
 * L'instance de l'interface qui sert de parent.
 */
   private IHM interf = null;
   
   private Font font;
    
/**
 * 
 */
   PanelDraw(IHM interf, Color bkColor) {
      this.interf = interf;
      setBackground (bkColor);
      setBorder (BorderFactory.createLineBorder (Color.gray));
      addMouseListener (new thisMouseListener());
      addMouseMotionListener (new thisMouseMotionListener());
      font = new Font ("SansSerif", Font.PLAIN, 12);
    } // end PanelDraw        

/**
 * 
 */
     PanelDraw(IHM interf) {
        this (interf, Color.white);
    } // end PanelDraw


/**
 * 
 */
   public void paint(Graphics g) {
      g.setFont (font);
      super.paint(g);
      int i;
      // Dessin des rseaux en premier
      Network n = null;
      for (i=0; i < interf.getNetsCount(); i++) {
         n = interf.getNet (i);
         n.drawIt ((Graphics2D)g);
      }
      Symbole s = null;
      for (i=0; i < interf.getSymbolesCount(); i++) {
         s = interf.getSymbole (i);
         s.drawIt ((Graphics2D)g);
         if (s == interf.getSelection()) {
            s.drawSelection ((Graphics2D)g);
         }
      }
    } // end paint

/**
 * Classe pour les venements de souris
 */
class thisMouseListener extends MouseAdapter {
   public void mousePressed(MouseEvent e) {
      mouseLastX = e.getX();
      mouseLastY = e.getY();
      switch (e.getButton()) {
         case MouseEvent.BUTTON1:         
            interf.graphLeftClick (mouseLastX, mouseLastY);
            break;
         case MouseEvent.BUTTON3:            
            interf.graphRightClick (mouseLastX, mouseLastY);
            break;
      }
   } // end mousePressed

/**
 * 
 */
   public void mouseReleased(MouseEvent e) {
         mouseLastX = e.getX();
         mouseLastY = e.getY();
   } // end mouseReleased        
} // end PanelDraw.thisMouseListener

/**
 * Classe pour les venements de dplacement souris.
 */
class thisMouseMotionListener extends MouseMotionAdapter {
   public void mouseDragged(MouseEvent e) {
      interf.graphMouseMoved (mouseLastX, mouseLastY, e.getX(), e.getY(), true);
      mouseLastX = e.getX();
      mouseLastY = e.getY();
   } // end mouseDragged        

   public void mouseMoved(MouseEvent e) {
      interf.graphMouseMoved (mouseLastX, mouseLastY, e.getX(), e.getY(), false);
      mouseLastX = e.getX();
      mouseLastY = e.getY();
   } // end mouseMoved
    
} // end PanelDraw.thisMouseMotionListener

} // end PanelDraw
