package ihm;

import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JComponent;

public class SymbMenu extends JPopupMenu implements ActionListener {

   private Symbole   symb;
   private IHM       ihm;
   private JMenuItem miProp;
   private JMenuItem miAlerts;
   private JMenuItem miSuppr;
   
   public SymbMenu (IHM interf, Symbole symbole, JComponent parent, int popX, int popY) throws IllegalArgumentException {
      super ((symbole == null ? "Erreur" : symbole.getName()));
      
      if ((symb = symbole) == null) {
         throw new IllegalArgumentException ("Le symbole associ au menu est null");
      }
      if ((ihm = interf) == null) {
         throw new IllegalArgumentException ("L'interface associe au menu est null");
      }
      
      miProp = new JMenuItem("Proprits");
      miProp.addActionListener (this);
      miAlerts = new JMenuItem("Alertes");
      miAlerts.addActionListener (this);
      if (symbole.getAlertPendingCount () <= 0) {
         miAlerts.setEnabled(false);
      }
      miSuppr = new JMenuItem("Supprimer");
      miSuppr.addActionListener (this);

      add(miProp);
      add(miAlerts);
      add(miSuppr);
      
      pack();
      show(parent, popX, popY);
   }
   
   public void actionPerformed (ActionEvent e) {
      if (e.getSource() == miProp) {
         ihm.changeSelSymbProp();
      } else if (e.getSource() == miAlerts) {
         ihm.showSelectedAlerts();
      } else if (e.getSource() == miSuppr) {
         ihm.removeSelected ();
      }
   }
}