package moteur;

import java.io.File;

/**
 * <p>Titre : </p>
 *
 * <p>Description : </p>
 *
 * <p>Copyright : Copyright (c) 2006</p>
 *
 * <p>Socit : </p>
 *
 * @author non attribuable
 * @version 1.0
 */
public class Configuration implements java.io.Serializable{

    static final long serialVersionUID = 1L;

    // les different chemin d'acces
    String pathApp;
    String pathLog;
    String pathSav;
    String pathDtd;

    // les differentes alerte possible
    boolean alertByLog;
    boolean alertByDiagram;
    boolean alertByWindow;



    public Configuration() {
        pathApp = "";
        pathLog = "";
        pathSav = "";
        pathDtd = "";
        alertByLog = true;
        alertByDiagram = true;
        alertByWindow = true;

    }

    public void setAlertByLog(boolean _b)
    {
        alertByLog = _b;
    }

    public void setAlertByDiagram(boolean _b)
    {
        alertByDiagram = _b;
    }

    public void setAlertByWindow(boolean _b)
    {
        alertByWindow = _b;
    }


    public void setPathDtd(String path)
    {
        pathDtd = replaceSeparator(path);
    }

    public void setPathApp(String path)
    {
        pathApp = replaceSeparator(path);
    }

    public void setPathLog(String path)
    {
        pathLog = replaceSeparator(path);
    }

    public void setPathSav(String path)
    {
        pathSav = replaceSeparator(path);
    }


    public String getPathDtd()
    {
        return pathDtd;
    }


    public String getPathApp()
    {
        return pathApp;
    }

    public String getPathLog()
    {
        return pathLog;
    }

    public String getPathSav()
    {
        return pathSav;
    }

    public boolean getAlertByLog()
    {
        return alertByLog;
    }

    public boolean getAlertByDiagram()
    {
        return alertByDiagram;
    }

    public boolean getAlertByWindow()
    {
        return alertByWindow;
    }

    public String replaceSeparator(String path)
    {
        if( (!(path.endsWith("\\"))) && (!(path.endsWith("/"))) ) path = path + File.separator;
        java.util.StringTokenizer st = new java.util.StringTokenizer(path,"/\\",true);
        String s = "";
        while (st.hasMoreElements()) {
            String temp = st.nextToken();
            if (temp.equals("\\") || temp.equals("/")) s = s + File.separator;
            else s = s + temp;
        }
        return s;
    }

    public String toString(){
        String s = "";
        s = s + pathApp;
        s = s+"\npathLog : "+pathLog;
        s = s+"\npathSav : "+pathSav;
        s = s+"\npathDTD : "+pathDtd;
        s = s+"\nalertByLog : "+alertByLog;
        s = s+"\nalertByDiagram : "+alertByDiagram;
        s = s+"\nalertByWindow : "+alertByWindow;
        return s;
    }

    public Configuration clone(){
        Configuration c = new Configuration();
        c.setPathApp(this.getPathApp());
        c.setPathLog(this.getPathLog());
        c.setPathSav(this.getPathSav());
        c.setPathDtd(this.getPathDtd());

        c.setAlertByLog(this.getAlertByLog());
        c.setAlertByDiagram(this.getAlertByDiagram());
        c.setAlertByWindow(this.getAlertByWindow());
        return c;
    }
}
