package moteur;

import java.io.File;
import java.io.IOException;
import java.util.Vector;

import javax.xml.parsers.*;

import moteur.*;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class ConfigurationHandler extends DefaultHandler{

   private Configuration conf;

   private boolean inconf, inpath_app, inpath_log, inpath_sav, inpath_dtd, inAlertByLog, inAlertByDiagram, inAlertByWindow;

   //------------------------
   //constructeurs
   //------------------------

   public ConfigurationHandler(){
      super();

   }

   //------------------------
   //setteurs
   //------------------------

   //------------------------
   //getteurs
   //------------------------

   //------------------------
   //methodes
   //------------------------

   //dtection d'ouverture de balise
   public void startElement(String uri,
                         String localName,
                         String qName,
                         Attributes attributes)
                  throws SAXException{
      qName = qName.toLowerCase();
      if(qName.equals("configuration")){
         inconf = true;
      }else if(qName.equals("pathapp")){
         inpath_app = true;
      }else if(qName.equals("pathlog")){
          inpath_log = true;
      }else if(qName.equals("pathsav")){
          inpath_sav = true;
      }else if(qName.equals("pathdtd")){
          inpath_dtd = true;
      }else if(qName.equals("alertbylog")){
          inAlertByLog = true;
      }else if(qName.equals("alertbydiagram")){
          inAlertByDiagram = true;
      }else if(qName.equals("alertbywindow")){
          inAlertByWindow = true;
      }
      else{
         //erreur, on peut lever une exception
         throw new SAXException("Balise "+qName+" inconnue.");
      }
   }

   //dtection fin de balise
   public void endElement(String uri,
                       String localName,
                       String qName)
                throws SAXException{
      qName = qName.toLowerCase();
      if(qName.equals("configuration")){
         inconf = false;
      }else if(qName.equals("pathapp")){
         inpath_app= false;
      }else if(qName.equals("pathlog")){
         inpath_log = false;
      }else if(qName.equals("pathsav")){
         inpath_sav = false;
      }else if(qName.equals("pathdtd")){
         inpath_dtd = false;
      }else if(qName.equals("alertbylog")){
         inAlertByLog = false;
      }else if(qName.equals("alertbydiagram")){
         inAlertByDiagram = false;
      }else if(qName.equals("alertbywindow")){
         inAlertByWindow = false;
      }else{
         //erreur, on peut lever une exception
         throw new SAXException("Balise "+qName+" inconnue.");
      }
   }

   //dtection de caractres
   public void characters(char[] ch,
                       int start,
                       int length)
                throws SAXException{
      String lecture = new String(ch,start,length);
      if (inpath_app)
      {
          conf.setPathApp(lecture);
      }
      if (inpath_log)
      {
          conf.setPathLog(lecture);
      }
      if (inpath_sav)
      {
          conf.setPathSav(lecture);
      }
      if (inpath_dtd)
      {
          conf.setPathDtd(lecture);
      }
      if (inAlertByLog)
      {
          conf.setAlertByLog(lecture.equals(new String("true")));
      }
      if (inAlertByDiagram)
      {
          conf.setAlertByLog(lecture.equals(new String("true")));
      }
      if (inAlertByWindow)
      {
          conf.setAlertByLog(lecture.equals(new String("true")));
      }

   }

   //dbut du parsing
   public void startDocument() throws SAXException {
         conf = new Configuration();
   }

   //fin du parsing
   public void endDocument() throws SAXException {

   }


   public Configuration getConfiguration(){
       return conf;
   }


}
