package moteur;

import java.util.Vector;
import java.util.Iterator;

public class Reseau {
    Vector<ElementReseau> elements;


    //------------------------
    //constructeurs
    //------------------------

    public Reseau() {
        elements = null;
    }



    //------------------------
    //setteurs
    //------------------------

    public void setElements(Vector<ElementReseau> elements){
        this.elements = new Vector<ElementReseau>(elements);
    }

    //------------------------
    //getteurs
    //------------------------

    public Vector<ElementReseau> getElements(){
        return this.elements;
    }


    //------------------------
    //methodes
    //------------------------

    public String toString(){
        String s = "";
        if(this.elements != null)
        {
            Iterator it = this.elements.iterator();
            while (it.hasNext()) s = s + " \n" + it.next();
        }
        return s;
    }

    //retourne le nombre d'element
    public int nbElements(){
        if(this.elements == null) return -1;
        else return this.elements.size();
    }

    //determine s'il existe un element
    public boolean containsElement(Object element)
    {
        if( this.elements == null) return false;
        if(nbElements() <= 0) return false;
        if(element != null)
        {
            if(element instanceof ElementReseau)
            {
                Iterator it = this.elements.iterator();
                   while(it.hasNext())
                       if( (((ElementReseau)it.next()).getIntegerId()).equals(((ElementReseau)element).getIntegerId()) ) return true;
                return false;
            }
            else if(element instanceof Integer)
            {
                Iterator it = this.elements.iterator();
                while(it.hasNext())
                    if( (((ElementReseau)it.next()).getIntegerId()).equals((Integer)element) ) return true;
                return false;
            }
            else return false;
        }
        else return false;
    }

    //determine s'il existe un element dont l'identifiant est id
    public boolean containsElement(int id)
    {
        if( this.elements == null) return false;
        if(nbElements() <= 0) return false;
        Iterator it = this.elements.iterator();
        while (it.hasNext())
            if ((((ElementReseau) it.next()).getIntegerId()).equals(new Integer(id))) return true;
        return false;
    }



    //ajoute un element sans redondence
    public void addElement(ElementReseau element)
    {
        if (this.elements == null)
            this.elements = new Vector<ElementReseau>();
        if (!containsElement(element))
            this.elements.add((ElementReseau)element);

    }

    //retourne le premier element dans un ElementReseau
    public ElementReseau getFirstElement(){
        return (ElementReseau)this.elements.firstElement();
    }


    //retourne le dernier element dans un ElementReseau
    public ElementReseau getLastElement() {
        return (ElementReseau)this.elements.lastElement();
    }

    //creer un iterateur sur les elements
    public Iterator getElementsIterator() {
        return this.elements.iterator();
    }

    //retourne l'element  l'index dans un ElementReseau
    public ElementReseau getElement(int index) {
        if (nbElements() > 0 && index < nbElements() && index >= 0)return (
                ElementReseau)this.elements.get(index);
        else return null;
    }

    //ajoute un tableau d'ElementReseau sans redondence
    public void addElements(ElementReseau[] elements)
    {
        for(int i = 0; i<elements.length; i++) addElement(elements[i]);
    }

    //place un element  l'index sans redondence
    public void setElement(ElementReseau element, int index )
    {
        if(index >= 0 && index < nbElements())
        {
            if (!containsElement(element))
                this.elements.setElementAt(element, index);
        }
        else System.out.println(" index invalide");
    }

    //supprime l'element  l'index
    public void removeElementAt(int index)
    {
        if(index >= 0 && index < nbElements())
        {
            this.elements.removeElementAt(index);
        }
        else System.out.println("index invalide");
    }


    //supprime l'element
    public void removeElement(Object element) {
        if (element != null) {
            if (element instanceof ElementReseau)
            {
                int i = 0;
                Iterator it = this.elements.iterator();
                boolean test = false;
                while(it.hasNext())
                {
                    if (((ElementReseau) it.next()).getIntegerId().equals(((ElementReseau) element).getIntegerId()))
                    {
                        test = true;
                        break;
                    }
                    i++;
                }
                if(test) this.elements.remove(i);
            }
            else if (element instanceof Integer)
            {
                int i = 0;
                Iterator it = this.elements.iterator();
                boolean test = false;
                while(it.hasNext())
                {
                    if (((ElementReseau) it.next()).getIntegerId().equals((Integer) element))
                    {
                        test = true;
                        break;
                    }
                    i++;
                }
                if(test) this.elements.remove(i);
            }
            
        }
        else System.out.println("element invalide => doit tre non null");
    }

    //supprime l'element dont l'identifiant est id
    public void removeElement(int id)
    {
        removeElement(new Integer(id));
    }

    //retourne l'element dont l'identifiant est id
    public ElementReseau elementWithId(int id)
    {
        Iterator it = this.elements.iterator();
        while(it.hasNext())
        {
            ElementReseau e = (ElementReseau)it.next();
            if (e.getId() == id) return e;
        }
        return null;
    }

    //retourne l'element dont l'identifiant est id
    public ElementReseau elementWithId(Integer id)
    {
        Iterator it = this.elements.iterator();
        while(it.hasNext())
        {
            ElementReseau e = (ElementReseau)it.next();
            if (e.getIntegerId().equals(id)) return e;
        }
        return null;
    }
	
	
    //retourne l'element dont la premiere interface est ip
    public ElementReseau elementWithIp(String ip)
    {
        Iterator it = this.elements.iterator();
        while(it.hasNext())
        {
            ElementReseau e = (ElementReseau)it.next();
            if ((e.getIpContact()).equals(ip)) return e;
        }
        return null;
    }
	
	
    public Reseau clone(){
        Reseau r = new Reseau();
        r.setElements(this.getElements());
        return r;
    }

}
