package moteur;


import java.io.File;
import java.io.IOException;
import java.lang.reflect.Method;

import javax.xml.parsers.*;

import moteur.ElementReseau;
import moteur.Reseau;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import java.util.Vector;
import java.util.Iterator;

public class XmlOutils {

    public static boolean test;

    //------------------------
    //constructeurs
    //------------------------
    public XmlOutils() {
    }

    //------------------------
    //setteurs
    //------------------------

    //------------------------
    //getteurs
    //------------------------

    //------------------------
    //methodes
    //------------------------
    /*
    //renvoi un tableau des champs de la classe
    public static java.lang.reflect.Field[] getFields(Class c){
        java.lang.reflect.Field[] fs = new java.lang.reflect.Field[0];
        if(c.getSuperclass() != null )
        {
            fs = getFields(c.getSuperclass());
        }
        java.lang.reflect.Field[] f = new java.lang.reflect.Field[fs.length + c.getDeclaredFields().length];
        int y = 0;
        for(int i = 0; i<fs.length; i++){ f[y] = fs[i]; y++;}
        for(int i = 0; i <c.getDeclaredFields().length; i++) { f[y] = c.getDeclaredFields()[i]; y++;}
        return f;
    }

    //lance la methode "nomMethode" sur l'objet "obj"
    public static Object lancerMethode(Object obj, Object[] args, String nomMethode) throws Exception
    {
       Class[] paramTypes = null;
       if(args != null)
       {
          paramTypes = new Class[args.length];
          for(int i=0;i<args.length;++i)
          {
             paramTypes[i] = args[i].getClass();
          }
       }
       Method m = obj.getClass().getMethod(nomMethode,paramTypes);
       return m.invoke(obj,args);
   }
  */
   //ajoute un espace
    public static String indent(int i){
        String s = "";
        for(int j = 0; j < i; j++) s=s+" ";
        return s;
    }

    //creer le fichier xml "fic" correspondant au reseau "r"
    public static boolean reseau2XmlFile(File fichier, Reseau reseau, String dtd)
    {
        try{
            java.io.PrintWriter f = new java.io.PrintWriter( new java.io.FileWriter (fichier));
            String xml = Object2Xml(reseau);
            if(!xml.equals(""))
            {
                f.println("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>");
                f.println("<!DOCTYPE reseau SYSTEM \"file:" + dtd + "\" >");
                f.print(xml);
                f.close();
                return true;
            }
        }
        catch(Exception e){ return false;}
        return false;
    }


    //creer le reseau a partir du fichier xml "nomFichier"
    public static Reseau XmlFile2Reseau(File fichier){
        Reseau r = null;
        try {
            // cration d'une fabrique de parseurs SAX
            SAXParserFactory fabrique = SAXParserFactory.newInstance();
            fabrique.setFeature("http://xml.org/sax/features/validation", true);
            // cration d'un parseur SAX
            SAXParser parseur = fabrique.newSAXParser();

            // lecture d'un fichier XML avec un DefaultHandler
            test = true;
            ReseauHandler gestionnaire = new ReseauHandler()
            {
                public void error(SAXParseException exception) {
                    System.out.println("ERREUR DOCUMENT XML NON VALIDE");
                    System.out.println(exception);
                    test=false;
                }
                public void fatalError(SAXParseException exception) {
                    System.out.println("ERREUR FATALE DOCUMENT XML NON VALIDE");
                    System.out.println(exception);
                    test = false;
                }
                public void warning(SAXParseException exception) {
                    System.out.println("AVERTISSEMENT DOCUMENT XML NON VALIDE");
                    System.out.println(exception);
                    //exception.printStackTrace();
                    test = false;
                }
            };

            //parseur.getXMLReader().setEntityResolver(gestionnaire);
            parseur.parse(fichier, gestionnaire);
            if(test && gestionnaire.isValid())
            {
                return gestionnaire.getReseau();
            }

        } catch (ParserConfigurationException pce) {
            System.out.println("Erreur de configuration du parseur");
            System.out.println("Lors de l'appel  SAXParser.newSAXParser()");
            System.out.println(pce);
        } catch (SAXException se) {
            System.out.println("Erreur de parsing");
            System.out.println("Lors de l'appel  parse()");
            System.out.println(se);
        } catch (IOException ioe) {
            System.out.println("Erreur d'entre/sortie");
            System.out.println("Lors de l'appel  parse()");
            System.out.println(ioe);
        }
        return null;
    }


    //renvoi sous forme d'une chaine la conversion du reseau "o" en xml
    public static String Object2Xml(Reseau reseau){
        String xml = "<reseau> \n";
        java.util.Iterator it = reseau.getElementsIterator();
        while(it.hasNext())
        {
            String temp = Object2Xml((ElementReseau)it.next(),1);
            if(!temp.equals(""))
                xml=xml + temp + "\n";
            else return "";
        }
        xml = xml + "</reseau> \n";
        return xml;
    }

    //renvoi sous forme d'une chaine la conversion de l'element reseau "o" en xml
    public static String Object2Xml(ElementReseau element, int indent){
        String xml = "";
        try {

            String type = ET.getTypeName(element.getType());
            String name = element.getNom();
            xml = xml + indent(indent) +"<"+type.toLowerCase()+">";
            indent ++;
            xml = xml + "\n" + indent(indent) +"<id>"+element.getIntegerId().toString()+"</id>";
            if( ! name.equals(""))
                xml = xml + "\n" + indent(indent) +"<nom>"+name+"</nom>";
                
			String ip = element.getIpContact();
            if( ! ip.equals(""))
                xml = xml + "\n" + indent(indent) +"<ipcontact>"+ip+"</ipcontact>";
                
			String anneau = element.getCommunity();
            if( ! anneau.equals(""))
                xml = xml + "\n" + indent(indent) +"<community>"+anneau+"</community>";		
    
            if(element.nbElements() > 0)
            {
                xml = xml + "\n" + indent(indent) +"<elements>";
                indent++;
                Iterator<Integer> it = element.getElementsIterator();
                while(it.hasNext())
                    xml = xml + "\n" + indent(indent) + "<id>"+((Integer)it.next()).toString()+"</id>";
                indent --;
                xml = xml + "\n" + indent(indent) +"</elements>";
            }
            indent --;
            xml = xml + "\n" + indent(indent) + "</" + type.toLowerCase() + ">";

        }
        catch(Exception e){ return "";}

        return xml;
    }







}
