package reseau;

import java.util.Iterator;
import java.util.Vector;

public class MibModuleLibrary {
	private	Vector<MibModule>	lib;
	private	MibTree				rootTree;
	
	public MibModuleLibrary() {
		lib = new Vector<MibModule>();
/*		MibModule m = new MibModuleSnmpSmi(this);
		m.displayModule();*/
		MibModule m = new MibModuleSnmpSmi(this);
		lib.add(m);
		lib.add(new MibModuleSnmpConf(this));
		lib.add(new MibModuleSnmpTc(this));
		lib.add(new MibModuleIANA(this));
		rootTree = m.getTree();
	}
	
	public void addModule(String path) throws MibParseErrorException {
		MibModule	mod;
		MibParser	parser;
		boolean		error = false;
		
		parser = new MibParser(path);
		mod = new MibModule(this, parser);
		try {
			mod.parse();
		} catch (MibParseErrorException e) {
			error = true;
			throw e;
		}
		if (!error) lib.add(mod);
	}
	
	public MibModule getModule(String name) {
		MibModule	m;
		Iterator<MibModule>	i = lib.iterator();
		
		while (i.hasNext()) {
			m = (MibModule)i.next();
			if (name.compareTo(m.getName()) == 0)
				return m;
		}
		
		return null;
	}
	
	public MibTree getRootTree() {
		return rootTree;
	}
}
