package reseau;

import java.io.*;

public class MibParser {
	private BufferedReader	br;
	private	FileReader		file;
	
	private char[]			str;
	private int				str_len;
	private int				str_index;
	
	private char			end_char;
	
	public MibParser (String path) throws MibParseErrorException {
		try {
			file = new FileReader(path);
			br = new BufferedReader(file);
		} catch (FileNotFoundException e) {
			throw new MibParseErrorException();
		}
		
		str = new char[256];
		
		try {
			str_len = br.read(str, 0, 256);
			str_index = 0;
		} catch (IOException e) {
			throw new MibParseErrorException();
		}
	}
	
	public boolean ready() {
		return true;
	}

	private char nextChar() throws MibParseErrorException {
		char lu;
	
		if (str_index >= str_len) {
			str_index = 0;
			try {
				str_len = br.read(str, 0, 256);
				str_index = 0;		
			} catch (IOException e) {
				throw new MibParseErrorException();
			}
		}
		lu = str[str_index];
		str_index++;
		return lu;
	}
	
	public String endOfLine() throws MibParseErrorException {
		char			lu;
		StringBuffer	buf = new StringBuffer();
		
		lu = nextChar();
		
		if (lu == '\n') return "";
		
		while ( (lu == ' ') || (lu == '\n') ||
				(lu == '\r') || (lu == '\t') ) {
			lu = nextChar();
		}
		
		while (lu != '\n') {
			buf.append(lu);
			lu = nextChar();
		}
		
		return buf.toString();
	}
	
	public String nextItem() throws MibParseErrorException {
		char			lu;
		int				spaces = 0;
		int				tab_index, i;
		StringBuffer	buf = new StringBuffer();
		
		lu = nextChar();
		while ( (lu == ' ') || (lu == '\n') ||
				(lu == '\r') || (lu == '\t') ) {
			lu = nextChar();
			spaces++;
		}
		
		if (lu == '\"') {
			lu = nextChar();
			do {
				if (lu == '\n') {
					/*
					lu=nextChar();
					for (i=0; i<spaces && lu==' '; i++) lu=nextChar();
					if (i<spaces) buf.append('\n');
					lu = '\n';
					*/
					buf.append(lu);
					do {
						lu = nextChar();
						if (lu == '\n') buf.append(lu);
					} while (lu == '\n');
					for (i=0; i<spaces+1; i++) {
						lu=nextChar();
						if (lu=='\"') break;
					}
					//lu = '\n';
				}
				if (lu=='\"') break;
				buf.append(lu);
				lu = nextChar();
			} while ( (lu != '\"') );
			
			end_char = '\"';
		} else {
			while ( (lu != ' ') && (lu != '\r') &&
					(lu != '\t') && (lu != '\n') ) {
				buf.append(lu);
				lu = nextChar();
			}
			
			if (buf.charAt(buf.length()-1) == ','
				|| buf.charAt(buf.length()-1) == ';') {
				end_char = buf.charAt(buf.length()-1);
				buf.deleteCharAt(buf.length()-1);
			} else {
				end_char = ' ';
			}
		}
		
		String s = buf.toString();
		if (s.compareTo("--") == 0) {
			endOfLine();
			s = nextItem();
		}
		
		return s;
	}
	
	public char endChar() {
		return end_char;
	}
}
