package reseau;

import java.util.Random;

public class PDU extends TypeSequence {
	public static final byte NOERROR	= 0;
	public static final byte TOOBIG		= 1;
	public static final byte NOSUCHNAME	= 2;
	public static final byte BADVALUE	= 3;
	public static final byte READONLY	= 4;
	public static final byte GENERR		= 5;

	private TypeInteger		requestId;
	private TypeInteger		errorStatus;
	private TypeInteger		errorIndex;
	protected TypeSequence	variableBindings;
	
	protected class VarBind extends TypeSequence {
		public VarBind(TypeObject n, Type v) {
			super();
			add(n);
			add(v);
		}
		public TypeObject getObject() { return (TypeObject)get(0); }
		public Type getValue() { return (Type)get(1); }
	};

	public PDU (byte t) {
		super();
		setType(t);
		Random	r = new Random();
		long n = r.nextInt();
		if (n<0) n=-n;
		requestId = new TypeInteger(n,4);
		//requestId = new TypeInteger(3000000, 4);
		errorStatus = new TypeInteger(NOERROR,1);
		errorIndex = new TypeInteger(0,1);
		variableBindings = new TypeSequence();
		add(requestId);
		add(errorStatus);
		add(errorIndex);
		add(variableBindings);
	}
	
	public PDU (byte t, int len, byte tab[], int isos) {
		super(len, tab, isos);
		setType(t);
		if (type != Type.TRAP) {
			requestId = (TypeInteger)get(0);
			errorStatus = (TypeInteger)get(1);
			errorIndex = (TypeInteger)get(2);
			variableBindings = (TypeSequence)get(3);
		}
//		System.out.println("PDU cree : " + requestId + ":" + errorStatus + ":" + errorIndex);
	}
	
	public long getErrorStatus() {
		return errorStatus.getValue();
	}
	
	public long getErrorIndex() {
		return errorIndex.getValue();
	}
	
	public void addVar(TypeObject n, Type v) {
		variableBindings.add(new VarBind(n,v));
		updateContent();
	}
	
	public TypeSequence getVar(int index) {
		return (TypeSequence)variableBindings.get(index);
	}
}

