package reseau;

import java.net.*;

public class SnmpSocket extends DatagramSocket {
	private String			host;
	private int				port;
	private InetAddress		addr;

	public SnmpSocket(String h, int p) throws SocketException,UnknownHostException {
		super();
		setSoTimeout(1000);
		host = h;
		port = p;
		addr = InetAddress.getByName(h);
	}
	
	public SnmpSocket(String h) throws SocketException,UnknownHostException {
		super();
		setSoTimeout(1000);
		host = h;
		port = 161;
		addr = InetAddress.getByName(h);
	}
	
	public String getHost() {
		return host;
	}
	
	public int getPort() {
		return port;
	}
	
	public void send(Message m) throws java.io.IOException {
		DatagramPacket p = new DatagramPacket(m.getBytes(), m.getBytes().length, addr, port);
		send(p);
	}
	
	public Message receive(int isos) throws java.io.IOException {
		DatagramPacket p = new DatagramPacket(new byte[65536], 65536);
		receive(p);
		
		return Type.messageFromBytes(p.getData(), isos);
	}
	
/*	public Type	parseBytes (byte tab[]) {
		byte	type = tab[0];
		int		len;
	}*/
}
