package reseau;

public class TrapPDU extends PDU {
	private TypeObject		enterprise;
	private TypeIpAddress	agentAddr;
	private TypeInteger		genericTrap;
	private TypeInteger		specificTrap;
	private	TypeInteger		timeStamp;
	//private TypeSequence	variableBindings;
	
	public TrapPDU (int len, byte tab[]) {
		super(Type.TRAP, len, tab, 20);
//		setType(Type.TRAP);
		enterprise			= (TypeObject)get(0);
		agentAddr			= (TypeIpAddress)get(1);
		genericTrap			= (TypeInteger)get(2);
		specificTrap		= (TypeInteger)get(3);
		timeStamp			= (TypeInteger)get(4);
		variableBindings	= (TypeSequence)get(5);
	}
   
   public String getOID() {
      TypeSequence	var = getVar(0);
      return var.get(0).toString();
   }
   
   public String getIP() {
      return agentAddr.toString();
   }
   
   public int getError1() {
      return (int)genericTrap.getValue();
   }
   
   public int getError2() {
      return (int)specificTrap.getValue();
   }
   
   public int getTime() {
      return (int)timeStamp.getValue();
   }
   
   public String getText() {
      TypeSequence	var = getVar(0);
      return var.get(1).toString();
   }
	
	public String toString() {
		String ret = "[" + agentAddr.toString() + "] " + enterprise.toString()
			+ " " + genericTrap.toString() + " " + specificTrap.toString();
			
		for (int i=0; i<variableBindings.size(); i++) {
			TypeSequence	var = getVar(i);
			ret += "\n{ " + var.get(0).toString() + " - " + var.get(1).toString() + " }";
		}
		return ret;
	}
}
