package reseau;

import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

public class TypeObject extends Type {
	private int	values[];
	
	public TypeObject (int v[]) {
		super(Type.OBJECT, (byte)0);
		values = v;
		updateContent();
	}
	
	public TypeObject (String s) {
		super(Type.OBJECT, (byte)0);
		fromString(s);
	}
	
	public TypeObject (int len, byte tab[]) {
		super(Type.OBJECT, (byte)0);
		String	s = "";
		int		p = tab[0];
		
		s += "." + (int)(p / 40);
		s += "." + (p % 40);
			
		for (int i=1; i<len; i++) {
			if (tab[i] >= 0) {
				s += "." + tab[i];
			} else {
				int n = 0, val = 0;
				val = 128 * (tab[i] + 128);
				val += tab[i+1];
				i++;
				s += "." + val;
			}
		}
		
		fromString(s);
		content = tab;
	}
	
	protected void updateContent() {
		/*
		length = (byte)(values.length - 1);
		content = new byte[length];
		content[0] = (byte)(40 * values[0] + values[1]);
		for (int i=1; i<length; i++)
			content[i] = (byte)values[i+1];*/
		
		Vector<byte[]>	v = new Vector<byte[]>();
		v.add(intToByte(40*values[0] + values[1]));
		for (int i=2; i<values.length; i++) {
			v.add(intToByte(values[i]));
		}
		
		int	l = 0;
		Iterator<byte[]> ite = v.iterator();
		while (ite.hasNext()) {
			l += (ite.next()).length;
		}
		length = l;
		content = new byte[l];
		int i=0;
		ite = v.iterator();
		while (ite.hasNext()) {
			byte t[] = ite.next();
			for (int j=0; j<t.length; j++)
				content[i++] = t[j];
		}
	}
	
	private byte[] intToByte(int l) {
		byte	tab[];
	
		int p = l;
			
		int n = 1;
		while (p > 127) {
			n++;
			p = p/256;
		}

		tab = new byte[n];
		
		tab[n-1] = (byte)(l%128);
		
		int r = l/128;
		for (int i=n-2; i>=0; i--) {
			tab[i] = (byte)((byte)0x80 | (byte)(r%128));
			r = r/128;
		}
		
		return tab;
	}
	
	public String toString() {
		String	s = "";
		
		for (int i=0; i<values.length; i++) {
			s += "." + values[i];
		}
		return s;
	}
	
	public boolean fromString (String s) {
		StringTokenizer	tok = new StringTokenizer(s, ".");
		values = new int[tok.countTokens()];
		int i=0;
		while (tok.hasMoreTokens()) {
			values[i] = Integer.parseInt(tok.nextToken());
			i++;
		}
		updateContent();
		return true;
	}
}
