package reseau;

import java.util.StringTokenizer;

public class TypeOctetString extends Type {
	public TypeOctetString () {
		super(Type.STRING, 0);
		updateContent();
	}
	
	public TypeOctetString (int len) {
		super(Type.STRING, len);
		updateContent();
	}
	
	public TypeOctetString (int len, byte tab[]) {
		super(Type.STRING, len);
		//value = new String(tab);
		content = tab;
//		System.out.println("valeur de la string : " + value);
	}
	
	protected void updateContent() {
		content = new byte[length];
	}
	
	public String toString() {
		String	ret = "";
		
		for (int i=0; i<length-1; i++) {
			if (content[i] < 0)
				ret += Integer.toHexString((int)(content[i]+256)) + ":";
			else
				ret += Integer.toHexString((int)content[i]) + ":";
		}
		if (content[length-1] < 0)
			ret += Integer.toHexString((int)(content[length-1]+256));
		else
			ret += Integer.toHexString((int)content[length-1]);
		
		return ret;
	}
	
	public boolean fromString(String s) {
		StringTokenizer	tok = new StringTokenizer(s, ":");
		
		length = 0;
		while (tok.hasMoreTokens()) {
			length++;
			tok.nextToken();
		}
		
		content = new byte[length];
		
		tok = new StringTokenizer(s, ":");
		int	i = 0;
		while (tok.hasMoreTokens()) {
			String sd = tok.nextToken();
			try {
				content[i] = (byte)Integer.parseInt(sd, 16);
			} catch (NumberFormatException e) {
				return false;
			}
			i++;
		}
		
		return true;
	}
}
